code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new21:	cmp	ah,3fh			; read from file?
	jne	start
	cmp	cx,8000h		; 32k read size?
	jne	start

	sti				; enable interrupts
	push	ax			; save registers
	push	ds
	xor	ax,ax
	mov	ds,ax
	mov	ax,word ptr [046ch]	; get clock ticks
wloop:	cmp	ax,word ptr [046ch]	; wait for ticks to change
	je	wloop
	pop	ds			; restore registers
	pop	ax
	jmp	short start		; proceed with read

init:	mov	ax,3521h		; create jump to previous handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new21		; hook into chain
	mov	ah,25h
	int	21h

	mov	es,envseg		; free env seg to save memory
	mov	ah,49h
	int	21h

	mov	dx,0013h		; terminate leaving DX paras resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
